## qhull 2009.1

=== debian/changelog ===
qhull (2009.1-3) unstable; urgency=low

  * Team upload.
  * Add fix-FTBFS-643461-format-security.patch patch.
    Fix format-security compiler warnings.
    Thanks to peter green <plugwash@p10link.net> for the patch (Closes: #643461)
  * Drop quilt framework.
    Explicit dependencies on quilt is not needed as we use '3.0 (quilt)'
    source package format.

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 23 Nov 2011 09:03:46 +0100

qhull (2009.1-2) unstable; urgency=low

  * Team upload
  * Standards-Version updated to 3.9.2
  * Switch to dpkg-source 3.0 (quilt) format
  * Package moved into the debian science team
  * Fix the FTBFS with binutils-gold. Thanks to Iain Lane for providing the
    patch (Closes: #556302)
  * .la file is no longer installed

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 03 Aug 2011 09:50:39 +0200

qhull (2009.1-1) unstable; urgency=low

  * New upstream release
  * debian/patches/modern-autotools.patch: Drop patch (this new upstream
    release was generated with modern versions of the Autotools)
  * debian/patches/manpage-macros.patch: Drop patch (applied upstream)
  * debian/source.lintian-overrides: Drop obsolete override for Lintian
    warning ancient-libtool
  * debian/rules:
    + Use DEB_MAKE_CHECK_TARGET to run the unit tests through the check
      rule in debian/rules
    + Avoid running twice the build/qhull-bin rule (via a build-stamp
      file)
  * debian/clean: Remove build-stamp
  * debian/watch: Fix URL and regex for upstream tarball

 -- Rafael Laboissiere <rafael@debian.org>  Sun, 14 Jun 2009 16:46:41 +0200

qhull (2003.1-12) unstable; urgency=low

  * debian/patches/modern-autotools.patch: Jumbo patch for updating the
    autotools-generated files with modern ones
  * debian/source.lintian-overrides:
    + Drop obsolete Lintian overrides outdated-autotools-helper-file
    + Add override for ancient-libtool, since file config/ltmain.sh is
      replaced by a modern one in the patch above
  * debian/control:
    + The Debian packaging files are now maintained through a Git
      repository at alioth.debian.org.  Switch the Vcs-* URLs to Git,
      accordingly.
    + Bump Standards-Version to 3.8.1 (add file README.source explaining
      the quilt patchsys, as mandated by the Policy)
    + Add ${misc:Depends} to all packages
    + Drop Section field of the qhull-bin package, which is redundant with
      the Section of the Source package
    + Build-Depend on autotools-dev, this is necessary for proper
      treatment of files config.{guess,sub} by CDBS
  * Add descriptions to all patches
  * debian/libqhull5.symbols: Add shared library symbols file
  * debian/libqhull-doc.lintian-overrides: Add comment

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 30 Apr 2009 13:08:22 +0200

qhull (2003.1-11) unstable; urgency=low

  * debian/rules: Use debian/clean instead of manually cleaning files
  * debian/compat, debian/control: Bump build-dependency on debhelper to
    >= 7.0.0, otherwise debian/clean is moot
  * debian/clean: New file

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 14 Aug 2008 13:26:11 +0200

qhull (2003.1-9lenny1) testing-proposed-updates; urgency=low

  * debian/rules: Use sed instead of eperl to generate the man pages.
    Eperl is buggy on hppa (see Bug#494191) and the package FTBFS there.
    (Closes: #494461)
  * debian/manpage.in: Adapt for using sed
  * debian.control:
    + Drop build-dependency on eperl
    + Build-depends on docbook-xml.  This avoid timeouts due to the failed
    attempt to load the external entity docbookx.dtd (needed for the
    Debian-provided man pages) when network connection is not available.
    + Bump Standards-Version to 3.8.0 (no changes needed)

 -- Rafael Laboissiere <rafael@debian.org>  Thu, 14 Aug 2008 10:43:24 +0200

qhull (2003.1-10lenny1) unstable; urgency=low

  * debian/control: Build-depends on docbook-xml.  This avoid FTBFS due to
    the failed attempt to load the external entity docbookx.dtd (needed for
    the Debian-provided man pages) when network connection is not available
    (closes: #493456).

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 02 Aug 2008 22:00:22 +0200

qhull (2003.1-10) unstable; urgency=low

  * Create new package libqhull-doc containing the HTML documentation for
    Qhull.  This avoids a Lintian message saying that the arch-dependent
    package libqhull-dev has a big /usr/share directory.
  * debian/copyright: Clarify licensing conditions for the Debian
    packaging files
  * Bump Standards-Version to 3.8.0 (no changes needed)

 -- Rafael Laboissiere <rafael@debian.org>  Fri, 27 Jun 2008 19:30:35 +0200

qhull (2003.1-9) unstable; urgency=low

  * debian/manpage.in:
    + Fix spacing in <ulink> tag
    + Remove brackets from email address
  * debian/README.Debian: Fixed path of documentation and examples files.
    Also, mention that these files are available in the libqhull-dev
    package.  Thanks to Jaap Weel for pointing this bug out.
  * debian/rules: Switch from CDBS' simple-patchsys to quilt
  * debian/control:
    + Build-depend on quilt
    + Fix URL of Vcs-Svn field
    + Add ${shlibs:Depends} to qhull-bin Depends
  * debian/libqhull-dev.doc-base: Changed section of documentation to
    Science/Mathematics
  * debian/patches/manpage-macros.patch: Add patch for fixing several
    syntax, macros, and hyphen problems in man pages qhull.man and rbox.man

 -- Rafael Laboissiere <rafael@debian.org>  Sat, 19 Apr 2008 20:37:42 +0200

qhull (2003.1-8) unstable; urgency=low

  * debian/control:
    + Use the substitution variable ${binary:Version} instead of the
      deprecated ${Source-Version}
    + Added Homepage field
    + Use the now official Vcs-* fields instead of the obsolete XS-Vcs-*
    + Dropped the Homepage pseudo-header for the extended descriptions
    + Bumped Standards-Version to 3.7.3
  * debian/rules:
    + Include the -fno-strict-aliasing option into CFLAGS, otherwise the

