=== debian/watch ===
version=3
https://savannah.nongnu.org/files/?group=qhull qhull-([\d+\.]+)\.tar\.gz
