## qhull 2012.1

=== debian/changelog ===
qhull (2012.1-4) unstable; urgency=medium

  * Add convenience link to #include <qhull/qhull.h> to simplify transition.

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 13 Feb 2014 11:09:12 +0000

qhull (2012.1-3) unstable; urgency=medium

  * Simplify man page patch.
  * Support multi-arch.

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 13 Feb 2014 08:54:29 +0000

qhull (2012.1-2) unstable; urgency=medium

  * Build dependency on cmake is needed.
  * Remove ancient install-time scripts related to /usr/doc/ transition.
  * Create backwards-compatibility links in /usr/include/qhull/.

 -- Barak A. Pearlmutter <bap@debian.org>  Sat, 08 Feb 2014 22:45:45 +0000

qhull (2012.1-1) unstable; urgency=low

  * New upstream release (closes: #621909)
    - Port quilt patches to new upstream.
    - Upstream now supports cmake: use it instead of autotools.
      - This should address the binutils-gold issue (closes: #556302)
      - Ditto for undefined reference to pow@@GLIBC_2.2.5 (closes: #713546)
    - Upstream incremented to libqhull.so.6 so switch to libqhull6
      - Remove symbols file
    - Update many paths to account for upstream changes.
      - upstream installs .htm files intermingled with .h file in /usr/include,
        move the .htm to /usr/share/doc with symlinks for the .h files as they
        are referred to from the .htm files.  (These will be missing if the -doc
        package is installed without the -dev package, but it hardly seems worth
        adding a dependency.)
  * Add myself as uploader in debian/control (closes: #571875)
  * Fix wx include __POWERPC__ issue (closes: #640432)
  * Update/modify debian packaging
    - Switch to dh9 in debian/rules; flush cdbs.
    - Bump standards version
    - Various simplifications allowed by modern dh.
    - Move all dev docs to -doc; remove contrary stanza in README.Debian.
    - Activate single-debian-patch source option; see git for patch breakdown.
    - Gentler preinst /usr/share/doc/libqhull-dev symlink excision, and add
      preinst to similarly excise any /usr/share/doc/qhull-bin symlink.
    - Mash installed debian/tmp into shape ourselves.
  * Add quilt patches for minor issues: spelling, man page bug
  * Put Debian TODO file in -doc package

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 06 Feb 2014 13:43:21 +0000
