=== debian/control ===
--- 
+++ 
@@ -2,17 +2,22 @@
 Section: math
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Rafael Laboissiere <rafael@debian.org>
-Standards-Version: 3.9.2
-Build-Depends: debhelper (>= 7.0.0), docbook2x (>= 0.8.8-3), xsltproc,
- cdbs, docbook-xml, autotools-dev
+Uploaders: Barak A. Pearlmutter <bap@debian.org>
+Standards-Version: 3.9.5
+Build-Depends: debhelper (>= 9),
+	       dh-exec (>= 0.3),
+	       cmake,
+	       chrpath,
+	       docbook2x (>= 0.8.8-3), xsltproc, docbook-xml
 Homepage: http://www.qhull.org
 Vcs-Git: git://anonscm.debian.org/debian-science/packages/qhull.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/qhull.git
 
-Package: libqhull5
+Package: libqhull6
 Section: libs
 Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: calculate convex hulls and related structures (shared library)
  Qhull computes convex hulls, Delaunay triangulations, halfspace
@@ -25,7 +30,9 @@
 Package: libqhull-dev
 Section: libdevel
 Architecture: any
-Depends: libqhull5 (= ${binary:Version}), ${misc:Depends}
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: libqhull6 (= ${binary:Version}), ${misc:Depends}
 Description: calculate convex hulls and related structures (development files)
  Qhull computes convex hulls, Delaunay triangulations, halfspace
  intersections about a point, Voronoi diagrams, furthest-site
@@ -49,7 +56,7 @@
 
 Package: qhull-bin
 Architecture: any
-Depends: libqhull5 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
+Depends: libqhull6 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Suggests: geomview
 Description: calculate convex hulls and related structures (utilities)
  Qhull computes convex hulls, Delaunay triangulations, halfspace
